/*
 * lcd.h
 *
 *  Created on: 2022530
 *      Author: Administrator
 */
#ifndef USER_LCD_H_
#define USER_LCD_H_
#include "ch32v30x.h"
#include "debug.h"

//LCDҪ
typedef struct
{
    u16 width;          //LCD 
    u16 height;         //LCD ߶
    u16 id;               //LCD ID
    u8  dir;              //ƣ01
    u16  wramcmd;       //ʼдgramָ
    u16  setxcmd;       //xָ
    u16  setycmd;       //yָ
}_lcd_dev;

//LCD
extern   _lcd_dev lcddev; //LCDҪ
/////////////////////////////////////û///////////////////////////////////
#define USE_HORIZONTAL       0//Һ˳ʱת    0-0ת1-90ת2-180ת3-270ת

//////////////////////////////////////////////////////////////////////////////////
//LCDĳߴ
#define LCD_W 320
#define LCD_H 480

//TFTLCDҪõĺ
extern u16  POINT_COLOR;//ĬϺɫ
extern u16  BACK_COLOR; //ɫ.ĬΪɫ

////////////////////////////////////////////////////////////////////
//-----------------LCD˿ڶ----------------
#define GPIO_TYPE  GPIOA  //GPIO
#define LCD_CS   GPIO_Pin_4       //Ƭѡ            PA4
#define LCD_RS   GPIO_Pin_3       //Ĵ/ѡ PA2
#define LCD_RST  GPIO_Pin_2       //λ            PA3


//QDtechȫϵģܿƱûҲԽPWMڱ
#define LCD_LED PBout(LED) //LCD           PB9
//ʹùٷ⺯еײ㣬ٶȽ½14֡ÿ룬˾Ƽ
//IOֱӲĴIOˢʿԴﵽ28֡ÿ룡

//GPIOλߣ
#define LCD_CS_SET  GPIO_SetBits(GPIOA, LCD_CS)
#define LCD_RS_SET  GPIO_SetBits(GPIOA, LCD_RS)
#define LCD_RST_SET GPIO_SetBits(GPIOA, LCD_RST)

//GPIOλͣ
#define LCD_CS_CLR  GPIO_ResetBits(GPIOA, LCD_CS)
#define LCD_RS_CLR  GPIO_ResetBits(GPIOA, LCD_RS)
#define LCD_RST_CLR GPIO_ResetBits(GPIOA, LCD_RST)

//ɫ
#define WHITE       0xFFFF
#define BLACK       0x0000
#define BLUE        0x001F
#define BRED        0XF81F
#define GRED        0XFFE0
#define GBLUE       0X07FF
#define RED         0xF800
#define MAGENTA     0xF81F
#define GREEN       0x07E0
#define CYAN        0x7FFF
#define YELLOW      0xFFE0
#define BROWN           0XBC40 //ɫ
#define BRRED           0XFC07 //غɫ
#define GRAY            0X8430 //ɫ
//GUIɫ

#define DARKBLUE         0X01CF //ɫ
#define LIGHTBLUE        0X7D7C //ǳɫ
#define GRAYBLUE         0X5458 //ɫ
//ɫΪPANELɫ

#define LIGHTGREEN      0X841F //ǳɫ
#define LIGHTGRAY     0XEF5B //ǳɫ(PANNEL)
#define LGRAY                   0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE       0XA651 //ǳɫ(мɫ)
#define LBBLUE          0X2B12 //ǳɫ(ѡĿķɫ)

void LCD_Init(void);
void LCD_DisplayOn(void);
void LCD_DisplayOff(void);
void LCD_Clear(u16 Color);
void LCD_SetCursor(u16 Xpos, u16 Ypos);
void LCD_DrawPoint(u16 x,u16 y);//
u16  LCD_ReadPoint(u16 x,u16 y); //
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);
void LCD_SetWindows(u16 xStar, u16 yStar,u16 xEnd,u16 yEnd);

u16 LCD_RD_DATA(void);//ȡLCD
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue);
void LCD_WR_DATA(u8 data);
u16 LCD_ReadReg(u8 LCD_Reg);
void LCD_WriteRAM_Prepare(void);
void LCD_WriteRAM(u16 RGB_Code);
u16 LCD_ReadRAM(void);
u16 LCD_BGR2RGB(u16 c);
void LCD_SetParam(void);
void Lcd_WriteData_16Bit(u16 Data);
void LCD_direction(u8 direction );

//ȻٶȲ죬ʹĺ궨,ٶ.
//עҪȥlcd.cvoid LCD_WR_DATA(u16 data)Ŷ

#endif /* USER_LCD_H_ */
